/**
 * HyperNIFTY (NIFTY-Serve Offline Simulator) for REXX  Ver.1.x
 *                  copyright 1999, Naga(Kazuo Adachi)
 *                          mailto:nagaw@ibm.net
 *                          mailto:GDB00421@nifty.ne.jp
 *
 * HNIF.cmd 1.21 1999/11/10 13:48:10 Naga Exp
 *
 * HNIF.cmd
 * Revision 1.21  1999/11/10 13:48:10  Naga
 * ǐ̕\̃oO(Tail0폜)C.
 *
 * Revision 1.20  1999/10/24 05:01:09  Naga
 * IDƃnhꍇ̖̑΍.
 *
 * Revision 1.19  1999/10/11 12:22:31  Naga
 * logDir̐ݒ肵Y(łƂ̌݊)ւ̑΍.
 *
 * Revision 1.18  1999/09/16 09:16:34  Naga
 * Ot@Č@(fBNg̒`)ύX.
 *
 * Revision 1.17  1999/09/12 16:18:10  Naga
 * O̖ǊǗɊւoOC.
 * o^tH[̉c̖C.
 * ꎞ~(more>\)̍svZ̕@ύX.
 *
 * Revision 1.16  1999/08/31 10:17:22  Naga
 * bZ[W̌oƈSɍs悤C.
 * C^[lbg[(INET GATE)ւ̑Ή.
 * [̉{yɍs悤C.
 *
 * Revision 1.15  1999/07/27 14:15:08  Naga
 * MESR}h1`20ȊOwȍC.
 * #P̂bZ[W̓ǂƉ߂̏C.
 *
 * Revision 1.14  1999/06/20 05:22:06  Naga
 * ƃfBNg̍쐬^C~ȌC.
 *
 * Revision 1.13  1999/06/19 07:04:39  Naga
 * ̖ǐ̌vZ萳m.
 * Revision̕\rcsCɕύX.
 * VALUE̋Lq(g)~XC.
 *
 * Revision 1.12  1999/06/18 09:03:30  Naga
 * 폜ɂ関ǌoȌC.
 *
 * Revision 1.11  1999/06/18 08:26:58  Naga
 * DOR}h̏ꕔC.
 * EXITR}h̒ǉ.
 * ĉڍׂȉ͂\.
 *
 * Revision 1.10  1999/04/01 03:48:22  Naga
 * c̎擾ɊւoȌC.
 *
 * Revision 1.9  1999/03/23 16:13:45  Naga
 * [ł̃[U[ID̐؂ooOC.
 *
 * Revision 1.8  1999/03/15 04:22:12  Naga
 * O͂̈S(p֘A).
 * [M̃nhw@\ǉ.
 * ݎ̃^Cg̃oOC.
 *
 * Revision 1.7  1999/03/13 17:37:24  Naga
 * MAILłREPLYR}hǉ.
 *
 * Revision 1.6  1999/03/13 17:05:21  Naga
 * MAIL@\̎g₷.
 * REREADR}h̒ǉ.
 * RER}h̎gp@ύX.
 *
 * Revision 1.5  1999/02/24 15:36:15  Naga
 * DOR}h̒ǉ.
 *
 * Revision 1.4  1999/02/23 12:23:34  Naga
 * MAIL֘AR}h̒ǉ.
 * COM/RESPR}h̏C.
 *
 * Revision 1.3  1999/02/21 17:38:55  Naga
 * ݎ̃^Cg̃oOC.
 *
 * Revision 1.2  1999/02/21 17:12:35  Naga
 * Ot@C̎w@ύX.
 * ̏̃oOC.
 * MREMES̃oOC.
 *
 * Revision 1.1  1999/02/21 16:13:49  Naga
 * Initial revision
 *
 */

SAY 'HyperNIFTY (NIFTY-Serve Offline Simulator) for REXX  Ver.1.21'
SAY '                   copyright 1999, Naga(Kazuo Adachi)'
SAY ''

CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
CALL SysLoadFuncs

ARG argFile

dirTemp = VALUE('TEMP'  ,, 'OS2ENVIRONMENT')
IF dirTemp = '' THEN
dirTemp = VALUE('TMP'   ,, 'OS2ENVIRONMENT')
IF dirTemp = '' THEN
dirTemp = VALUE('TMPDIR',, 'OS2ENVIRONMENT')
IF dirTemp = '' THEN dirTemp = '.\'
IF \(SUBSTR(dirTemp, LENGTH(dirTemp)) = '\') THEN dirTemp = dirTemp'\'
SAY 'TMPDIR =' dirTemp

/*--------------------------------------------------------*/
/** `t@C̓ǂݍ
 */
exeEditor = 'TEDIT.EXE'
morePause = 23
messFlush = 'OFF'
textQuote = '>'
handleTxt = ''
signupTxt = ''

logDir    = ''
logFile   = 'NIF????.LOG'
padFile   = 'PADMES.PAD'

iniFile   = 'HNIF.ini'

LINEIN(iniFile, 1, 0)
DO WHILE LINES(iniFile)
    iniLine = LINEIN(iniFile)
    IF POS('#', iniLine) > 0 THEN iniLine = DELSTR(iniLine, POS('#', iniLine))
    PARSE VAR iniLine iniName '=' iniVals
    PARSE UPPER VAR iniName iniName
    iniName = STRIP(iniName)
    iniVals = STRIP(iniVals)
    SELECT
        WHEN iniName = 'EDITOR'  THEN exeEditor = iniVals
        WHEN iniName = 'PAUSE'   THEN morePause = iniVals
        WHEN iniName = 'FLUSH'   THEN messFlush = TRANSLATE(iniVals)
        WHEN iniName = 'QUOTE'   THEN textQuote = iniVals
        WHEN iniName = 'HANDLE'  THEN handleTxt = iniVals
        WHEN iniName = 'SIGNUP'  THEN signupTxt = iniVals
        WHEN iniName = 'LOGDIR'  THEN logDir    = iniVals
        WHEN iniName = 'LOGFILE' THEN logFile   = iniVals
        WHEN iniName = 'PADFILE' THEN padFile   = iniVals
        OTHERWISE
    END
END
CALL LINEOUT iniFile
IF POS('', textQuote) = 1 THEN textQuote = ' 'textQuote

IF \(argFile = '') THEN logFile = argFile

IF \(logDir = '') THEN
DO
    IF \(SUBSTR(logDir,LENGTH(logDir)) = '\') THEN logDir = logDir||'\'
END
IF POS('\',logFile) > 0 THEN logDir = ''

/*--------------------------------------------------------*/
/** tH[̓ǂݍ
 */
nifForum.0 = 0

datFile   = 'HNIF.dat'

LINEIN(datFile, 1, 0)
DO WHILE LINES(datFile)
    datLine = LINEIN(datFile)
    IF POS('#', datLine) > 0 THEN datLine = DELSTR(datLine, POS('#', datLine))
    PARSE VAR datLine datName '=' datVals
    datName = STRIP(TRANSLATE(datName))
    datVals = STRIP(datVals)
    SELECT
        WHEN datName = 'FORUM' THEN
        DO
            nifForum.0 = nifForum.0 + 1
            rc = VALUE('nifForum.'nifForum.0, datVals)
            PARSE VAR datVals cmdForum nameForum
            DO i=1 to 20
                rc = VALUE(cmdForum'.mes.'i, '')
                rc = VALUE(cmdForum'.mes.'i'.max' , '')
                rc = VALUE(cmdForum'.mes.'i'.unrd', 0 )
                rc = VALUE(cmdForum'.mes.'i'.date', '')
            END
        END
        OTHERWISE
        DO i = 1 to nifForum.0
            PARSE VAR nifForum.i cmdForum nameForum
            PARSE VAR datName datForum '.' datMes00
            datForum = STRIP(datForum)
            datMes00 = STRIP(datMes00)
            IF cmdForum = datForum THEN
            DO
                PARSE VAR datMes00 'MES' datMesNo
                datMesNo = STRIP(datMesNo, 'L', '0')
                rc = VALUE(cmdForum'.mes.'datMesNo, datVals)
            END
        END
    END
END
CALL LINEOUT datFile

/*--------------------------------------------------------*/
/** C
 */
dateLogout = '00/00/00    00:00:00'
rc = SysFileTree(logDir||logFile, 'logFind', 'FO')
IF logFind.0 = 0 THEN
DO
    logFind.0 = 1
    logFind.1 = ''
END
DO idxFile = 1 TO logFind.0
    /** ƃfBNg̍쐬
     */
    rc = SysMkDir(dirTemp'NIFMAIL')
    DO i = 1 to nifForum.0
        PARSE VAR nifForum.i cmdForum nameForum
        rc = SysMkDir(dirTemp||cmdForum)
    END
    IF \(logFind.idxFile = '') THEN CALL logLoad logFind.idxFile

    SAY ''
    SAY '悤Hyper-NIFTY'
    SAY '  Copyright (C) 1999'
    SAY ' by Naga(Kazuo Adachi)'
    SAY ' All Rights Reserved'
    SAY ''
    SAY 'OLOG OUT' dateLogout
    rc = SysFileTree(dirTemp'NIFMAIL\*.*', 'mailFile', 'FO')
    IF mailFile.0 > 0 THEN
        SAY '||[' mailFile.0 'ʓ͂Ă܂iǕ' mailFile.0 'ʁj||'
    SAY ''
    doCommand = ''
    CALL topMenu

    /** Ɨpt@Čn
     */
    DO i=1 to nifForum.0
        PARSE VAR nifForum.i goForum nameForum
        DO j=1 to 20
            rc = VALUE(goForum'.mes.'j'.unrd', 0)
        END
        delDir = dirTemp||goForum
        rc = SysFileTree(delDir'\*.*', 'delFile', 'FO')
        DO j=1 to delFile.0
            rc = SysFileDelete(delFile.j)
        END
        rc = SysRmDir(delDir)
    END
    delDir = dirTemp'NIFMAIL'
    rc = SysFileTree(delDir'\*.*', 'delFile', 'FO')
    DO j=1 to delFile.0
        rc = SysFileDelete(delFile.j)
    END
    rc = SysRmDir(delDir)

    IF cmdStr = 'EXIT' THEN LEAVE
    IF cmdStr = 'QUIT' THEN LEAVE
END

EXIT

/*--------------------------------------------------------*/
/** TOPj[ǂ
 */
topMenu:
cmdStr = ''
DO FOREVER
    CALL CHAROUT , ''
    cmdStr = pullInput()

    PARSE VAR cmdStr cmdStr cmdOpt
    IF cmdStr = 'MYFORUM' THEN CALL myForum

    DO WHILE cmdStr = 'GO' | cmdStr = 'MAIL'
        IF cmdStr = 'MAIL' THEN CALL goMail
        IF cmdStr = 'GO'   THEN CALL goForum cmdOpt
    END

    IF cmdStr = 'EXIT' THEN LEAVE
    IF cmdStr = 'QUIT' THEN LEAVE
    IF cmdStr = 'BYE'  THEN LEAVE
    IF cmdStr = 'OFF'  THEN LEAVE
END
RETURN

/*--------------------------------------------------------*/
/** MAILj[ǂ
 */
goMail:
cmdRead = 0
cmdList = 0
cmdStr = ''
DO FOREVER
    CALL CHAROUT , 'MAIL>'
    cmdStr = pullInput()

    PARSE VAR cmdStr cmdStr cmdOpt
    IF cmdStr = 'MYFORUM' THEN CALL myForum

    IF (cmdStr = "") & (cmdRead > 0) & (cmdRead < cmdList) THEN
    DO
        cmdRead = cmdRead + 1
        CALL mailView cmdRead
    END
    IF (cmdStr > 0) & (cmdStr <= cmdList) THEN
    DO
        cmdRead = cmdStr
        CALL mailView cmdRead
    END
    IF POS(cmdStr, 'READ'   ) = 1 & LENGTH(cmdStr) > 2 THEN
    DO
        cmdRead = cmdOpt
        CALL mailView cmdRead
    END
    IF POS(cmdStr, 'COMPOSE') = 1 & LENGTH(cmdStr) > 2 THEN CALL mailCom 'NIFMAIL'
    IF POS(cmdStr, 'REPLY'  ) = 1 & LENGTH(cmdStr) > 2 THEN CALL mailCom 'NIFMAIL' 'MAIL' cmdRead
    IF POS(cmdStr, 'LIST'   ) = 1 & LENGTH(cmdStr) > 2 THEN
    DO
        CALL mailList
        cmdList = mailFile.0
    END

    IF cmdStr = 'EXIT' THEN LEAVE
    IF cmdStr = 'QUIT' THEN LEAVE
    IF cmdStr = 'BYE'  THEN LEAVE
    IF cmdStr = 'OFF'  THEN LEAVE
    IF cmdStr = 'E'    THEN LEAVE
    IF cmdStr = 'TT'   THEN LEAVE
    IF cmdStr = 'GO'   THEN LEAVE
END
RETURN

/*--------------------------------------------------------*/
/** FORUMj[ǂ
 */
goForum: ARG cmdForum
fndForum = 0
DO i=1 to nifForum.0
    PARSE VAR nifForum.i goForum '' nameForum ''
    IF goForum = cmdForum THEN
    DO
        fndForum = 1
        LEAVE
    END
END
IF fndForum = 0 THEN
DO
    cmdStr ='ERROR'
    SAY ''
    SAY 'tH[ <'cmdForum'> ́Ao^Ă܂B'
    SAY ''
    RETURN
END
SAY ''
SAY ''nameForum'    'goForum
cmdStr = ''
DO FOREVER
    CALL CHAROUT , 'FORUM>'
    cmdStr = pullInput()

    PARSE VAR cmdStr cmdStr cmdOpt
    IF cmdStr = 'MYFORUM' THEN CALL myForum

    DO WHILE cmdStr = 'MES'
        CALL goMes cmdForum cmdOpt
    END

    IF cmdStr = 'EXIT' THEN LEAVE
    IF cmdStr = 'QUIT' THEN LEAVE
    IF cmdStr = 'BYE'  THEN LEAVE
    IF cmdStr = 'OFF'  THEN LEAVE
    IF cmdStr = 'E'    THEN LEAVE
    IF cmdStr = 'TT'   THEN LEAVE
    IF cmdStr = 'MAIL' THEN LEAVE
    IF cmdStr = 'GO'   THEN LEAVE
END
IF cmdStr = 'E' THEN cmdStr = ''
RETURN

/*--------------------------------------------------------*/
/** cj[ǂ
 */
goMes: ARG cmdForum cmdMes
cmdMre  = 0
cmdRead = 0
cmdStr = ''
IF cmdMes = '' THEN
DO FOREVER
    IF cmdStr = '' | cmdStr = 'MES' THEN CALL mesForum cmdForum
    CALL CHAROUT , ''
    cmdStr = pullInput()

    PARSE VAR cmdStr cmdStr cmdOpt
    IF cmdStr = 'MYFORUM' THEN CALL myForum

    cmdMre = 0
    IF POS(cmdStr, 'MREAD') = 1 & LENGTH(cmdStr) > 2 THEN
    DO
        cmdStr = 'MES'
        cmdMre = 1
        cmdOpt = 0
        DO i = 1 TO 20
            IF \(VALUE(cmdForum'.mes.'i) = '') THEN
            DO
                cmdOpt = i
                LEAVE
            END
        END
        IF cmdOpt = 0 THEN
        DO
            SAY 'ݖǂ̔͂܂'
            cmdStr = ''
        END
    END
    IF cmdStr > 0 & cmdStr < 21 THEN
    DO
        cmdOpt = cmdStr
        cmdStr = 'MES'
    END
    DO WHILE cmdStr = 'MES' & \(cmdOpt = '')
        cmdMes = cmdOpt
        IF \(cmdMes = '') THEN CALL goMesNo cmdForum cmdMes
    END

    IF cmdStr = 'EXIT' THEN LEAVE
    IF cmdStr = 'QUIT' THEN LEAVE
    IF cmdStr = 'BYE'  THEN LEAVE
    IF cmdStr = 'OFF'  THEN LEAVE
    IF cmdStr = 'E'    THEN LEAVE
    IF cmdStr = 'TT'   THEN LEAVE
    IF cmdStr = 'MAIL' THEN LEAVE
    IF cmdStr = 'GO'   THEN LEAVE
    IF cmdStr = 'T'    THEN LEAVE
END
ELSE CALL goMesNo cmdForum cmdMes
IF cmdStr = 'E' THEN cmdStr = ''
RETURN

/*--------------------------------------------------------*/
/** cR}hǂ
 */
goMesNo: ARG cmdForum cmdMes
cmdMes = STRIP(cmdMes, 'L', '0')
IF \(cmdMes > 0 & cmdMes < 21) THEN
DO
    cmdStr ='ERROR'
    SAY ''
    SAY 'Yc܂'
    SAY ''
    RETURN
END
IF VALUE(cmdForum'.mes.'cmdMes) = '' THEN
DO
    cmdStr ='ERROR'
    SAY ''
    SAY 'c 'cmdMes' Ԃ́Ao^Ă܂B'
    SAY ''
    RETURN
END
DO FOREVER
    cmdRead = 0
    IF cmdMre = 1 THEN
    DO WHILE cmdRead = 0
        tmpFile = dirTemp||cmdForum'\'RIGHT(cmdMes, 2, 0)'??????.$$$'
        rc = SysFileTree(tmpFile, 'findFile', 'FO')
        IF findFile.0 > 0 THEN
        DO i = 1 TO findFile.0
            curRead = STRIP(SUBSTR(findFile.i, LENGTH(findFile.i) - 9, 6), 'L', '0')
            IF cmdRead = 0 | cmdRead > curRead THEN cmdRead = curRead
        END
        ELSE
        DO
            IF cmdMes < 20 THEN
            DO
                cmdMes = cmdMes + 1
            END
            ELSE RETURN
        END
        cmdStr = '#'cmdRead
    END
    varMes  = cmdForum'.mes.'cmdMes
    varMax  = STRIP(VALUE(varMes'.max') , 'L', '0')
    IF varMax  = '' THEN varMax  = '0'
    varUnrd = STRIP(VALUE(varMes'.unrd'), 'L', '0')
    IF varUnrd = '' THEN varUnrd = '0'
    SAY '|c'RIGHT(cmdMes, 2)'  'VALUE(varMes)'   :'varMax'  :'varUnrd'|'
    DO FOREVER
        IF cmdMre = 0 THEN
        DO
            CALL CHAROUT , 'CCS(N)>'
            cmdStr = pullInput()
        END
        ELSE cmdMre = 0

        IF POS(cmdStr, 'REREAD') = 1 & LENGTH(cmdStr) > 2 THEN
        DO
            cmdStr = ''
            cmdRead = cmdRead - 1
        END
        IF POS(cmdStr, 'MREAD' ) = 1 & LENGTH(cmdStr) > 2 THEN
        DO
            IF cmdRead = 0 THEN
            DO
                tmpFile = dirTemp||cmdForum'\'RIGHT(cmdMes, 2, 0)'??????.$$$'
                rc = SysFileTree(tmpFile, 'findFile', 'FO')
                IF findFile.0 > 0 THEN
                DO i = 1 TO findFile.0
                    curRead = STRIP(SUBSTR(findFile.i, LENGTH(findFile.i) - 9, 6), 'L', '0')
                    IF cmdRead = 0 | cmdRead > curRead THEN cmdRead = curRead
                END
                ELSE
                DO
                    IF cmdMes < 20 THEN
                    DO
                        cmdMes = cmdMes + 1
                        cmdMre = 1
                        LEAVE
                    END
                    ELSE RETURN
                END
            END
            cmdStr  = ''
            cmdRead = cmdRead - 1
        END
        IF cmdStr = '' & \(cmdRead = 0) THEN
        DO
            DO WHILE cmdStr = ''
                cmdRead = cmdRead + 1
                tmpFile = dirTemp||cmdForum'\'RIGHT(cmdMes, 2, 0)||RIGHT(cmdRead, 6, 0)'.$$$'
                rc = SysFileTree(tmpFile, 'findFile', 'FO')
                IF findFile.0 = 0 THEN
                DO
                    IF varMax <= cmdRead THEN
                    DO
                        IF cmdMes < 20 THEN
                        DO
                            cmdMes = cmdMes + 1
                            cmdMre = 1
                            LEAVE
                        END
                        ELSE RETURN
                    END
                END
                ELSE cmdStr = '#'cmdRead
            END
            IF cmdMre = 1 THEN LEAVE
        END

        PARSE VAR cmdStr cmdStr cmdOpt
        IF cmdStr = 'MYFORUM' THEN CALL myForum

        IF POS('#', cmdStr) = 1 & LENGTH(cmdStr) > 1 THEN
        DO
            cmdRead = DELSTR(cmdStr, 1, 1)
            CALL mesView cmdForum cmdMes cmdRead
        END

        IF cmdStr = 'SAY' THEN CALL mesSay cmdForum cmdMes
        IF cmdStr = 'RE'  THEN
        DO
            IF cmdOpt = '' THEN cmdOpt = cmdRead
            IF \(cmdOpt = 0) THEN CALL mesSay cmdForum cmdMes cmdOpt
        END
        IF POS(cmdStr, 'COMPOSE') = 1 &,
           LENGTH(cmdStr) > 2 THEN CALL mesSay  cmdForum cmdMes cmdRead
        IF POS(cmdStr, 'RESPONSE') = 1 &,
           LENGTH(cmdStr) > 3 THEN CALL mailCom cmdForum cmdMes cmdRead

        IF cmdStr = 'RMN' THEN CALL mesList cmdForum cmdMes
        IF cmdStr = 'RM'  THEN CALL mesList cmdForum cmdMes
        IF cmdStr = 'RTN' THEN CALL mesList cmdForum cmdMes
        IF cmdStr = 'RT'  THEN CALL mesList cmdForum cmdMes

        IF cmdStr = 'MES'  THEN LEAVE
        IF cmdStr = 'EXIT' THEN LEAVE
        IF cmdStr = 'QUIT' THEN LEAVE
        IF cmdStr = 'BYE'  THEN LEAVE
        IF cmdStr = 'OFF'  THEN LEAVE
        IF cmdStr = 'E'    THEN LEAVE
        IF cmdStr = 'TT'   THEN LEAVE
        IF cmdStr = 'MAIL' THEN LEAVE
        IF cmdStr = 'GO'   THEN LEAVE
        IF cmdStr = 'T'    THEN LEAVE
    END
    IF cmdMre = 0 THEN LEAVE
END
IF cmdStr = 'E' THEN cmdStr = ''
RETURN

/*--------------------------------------------------------*/
/** MYFORUMR}hǂ
 */
myForum:
SAY ''
DO i=1 to nifForum.0
    PARSE VAR nifForum.i goForum '' nameForum ''
    SAY RIGHT(i, 4)'  'LEFT(nameForum, 46)||goForum
END
RETURN

/*--------------------------------------------------------*/
/** cXg\[`
 */
mesForum: ARG cmdForum
SAY ''
SAY 'ԍ@ () @ŐV@@c'
DO i=1 to 20
    IF \(VALUE(cmdForum'.mes.'i) = '') THEN
    DO
        varMes  = cmdForum'.mes.'i
        varMax  = STRIP(VALUE(varMes'.max') , 'L', '0')
        IF varMax  = '' THEN varMax  = '0'
        varMax  = RIGHT(varMax , 5)
        varUnrd = STRIP(VALUE(varMes'.unrd'), 'L', '0')
        IF varUnrd = '' THEN varUnrd = '0'
        varUnrd = RIGHT(varUnrd, 4)
        varDate = VALUE(varMes'.date')
        IF varDate = '' THEN varDate = '00/00'
        SAY RIGHT(i, 2)'   'varMax' ('varUnrd')   'varDate'   'VALUE(varMes)
    END
END
RETURN

/*--------------------------------------------------------*/
/** [Xg\[`
 */
mailList:
rc = SysFileTree(dirTemp'NIFMAIL\MAIL*.$$$', 'mailFile', 'FO')
SAY 'MF'mailFile.0
SAY 'ԍ  M          t     薼'
DO i=1 to mailFile.0
    LINEIN(mailFile.i, 1, 0)
    mailLine0 = LINEIN(mailFile.i)
    mailLine1 = LINEIN(mailFile.i)
    mailLine2 = LINEIN(mailFile.i)
    PARSE VAR mailLine1 numMail handle
    numMail  = STRIP(numMail)
    idUser   = STRIP(SUBSTR(handle, 20, 8))
    dateMail = STRIP(SUBSTR(handle, 41, 5))
    handle   = STRIP(DELSTR(handle, 20))
    PARSE VAR mailLine2 '    薼F' title
    title    = STRIP(title)
    IF handle = 'INET GATE' THEN
    DO
        DO FOREVER
            mailLine0 = LINEIN(mailFile.i)
            IF mailLine0 = '' THEN LEAVE
        END
        ReplyTo = 0
        DO FOREVER
            mailLine0 = LINEIN(mailFile.i)
            IF mailLine0 = '' THEN LEAVE
            PARSE VAR mailLine0 mailHead ':' mailText
            mailHead = STRIP(mailHead)
            mailText = STRIP(mailText)
            IF TRANSLATE(mailHead) = 'FROM' & ReplyTo = 0 THEN
            DO
                idUser = mailText
                IF POS('<', idUser) > 0 THEN
                DO
                    handle = SUBSTR(idUser, 1, LASTPOS('<', idUser)-1)
                    idUser = SUBSTR(idUser, LASTPOS('<', idUser)+1)
                    idUser = SUBSTR(idUser, 1,  POS('>', idUser)-1)
                    idUser = STRIP(idUser)
                    handle = STRIP(handle)
                END
            END
            IF TRANSLATE(mailHead) = 'REPLY-TO' THEN
            DO
                idUser = mailText
                ReplyTo = 1
            END
        END
        idUser = 'INET:'idUser
    END
    SAY RIGHT(numMail, 3)'   'LEFT(handle, 16)||dateMail'    'title
    CALL LINEOUT mailFile.i
END
RETURN

/*--------------------------------------------------------*/
/** [\[`
 */
mailView: ARG cmdRead
tmpFile = dirTemp'NIFMAIL\MAIL'RIGHT(cmdRead, 4, 0)'.$$$'
LINEIN(tmpFile, 1, 0)
IF LINES(tmpFile) = 1 & messFlush = 'ON' THEN CALL SysCls
cntPause = 0
DO WHILE LINES(tmpFile)
    tmpLine = LINEIN(tmpFile)
    SAY tmpLine
    cntPause = cntPause + TRUNC(LENGTH(tmpLine) / 80) + 1
    IF cntPause >= morePause THEN
    DO
        CALL CHAROUT , 'more>'
        dmyCmd = pullInput()
        cntPause = 0
    END
END
CALL LINEOUT tmpFile
RETURN

/*--------------------------------------------------------*/
/** [쐬[`
 */
mailCom: ARG cmdForum cmdMes reMes
sayFile = dirTemp'NIFMAIL\NEW_MAIL.$$$'
CALL LINEOUT sayFile,, 1
IF \(cmdForum = 'NIFMAIL') THEN
DO
    tmpFile = dirTemp||cmdForum'\'RIGHT(cmdMes, 2, 0)||RIGHT(reMes, 6, 0)'.$$$'
    LINEIN(tmpFile, 1, 0)
    sayLine = LINEIN(tmpFile)
    PARSE VAR sayLine numMes '/' maxMes idUser title
    numMes = STRIP(numMes)
    maxMes = STRIP(maxMes)
    idUser = STRIP(idUser)
    handle  = DELSTR(title,    17)
    title   = DELSTR(title, 1, 18)
    handle  = STRIP(handle)
    title   = STRIP(title )
    IF \(TRANSLATE(DELSTR(title, 4)) = 'RE:') THEN
    DO
        title = 'RE:'title
    END
    CALL LINEOUT sayFile, 'TO:'idUser
    CALL LINEOUT sayFile, 'SUB:'title
    IF \(handleTxt = '') THEN CALL LINEOUT sayFile, 'FROM:'handleTxt
    CALL LINEOUT sayFile, ''
    LINEIN(tmpFile, 1, 0)
    DO WHILE LINES(tmpFile)
        CALL LINEOUT sayFile, textQuote||LINEIN(tmpFile)
    END
    CALL LINEOUT tmpFile
    SAY '- 'idUser'@ւ̃X|X -'
END
ELSE
DO
    IF reMes = '' THEN
    DO
        CALL LINEOUT sayFile, 'TO:NONE'
        CALL LINEOUT sayFile, 'SUB:NONE'
        IF \(handleTxt = '') THEN CALL LINEOUT sayFile, 'FROM:'handleTxt
    END
    ELSE
    DO
        tmpFile = dirTemp'NIFMAIL\MAIL'RIGHT(reMes, 4, 0)'.$$$'
        LINEIN(tmpFile, 1, 0)
        mailLine0 = LINEIN(tmpFile)
        mailLine1 = LINEIN(tmpFile)
        mailLine2 = LINEIN(tmpFile)
        PARSE VAR mailLine1 numMail handle
        numMail  = STRIP(numMail)
        idUser   = STRIP(SUBSTR(handle, 20, 8))
        dateMail = STRIP(SUBSTR(handle, 41, 5))
        handle   = STRIP(DELSTR(handle, 20))
        PARSE VAR mailLine2 '    薼F' title
        title    = STRIP(title)
        IF handle = 'INET GATE' THEN
        DO
            DO FOREVER
                mailLine0 = LINEIN(tmpFile)
                IF mailLine0 = '' THEN LEAVE
            END
            ReplyTo = 0
            DO FOREVER
                mailLine0 = LINEIN(tmpFile)
                IF mailLine0 = '' THEN LEAVE
                PARSE VAR mailLine0 mailHead ':' mailText
                mailHead = STRIP(mailHead)
                mailText = STRIP(mailText)
                IF TRANSLATE(mailHead) = 'FROM' & ReplyTo = 0 THEN
                DO
                    idUser = mailText
                    IF POS('<', idUser) > 0 THEN
                    DO
                        handle = SUBSTR(idUser, 1, LASTPOS('<', idUser)-1)
                        idUser = SUBSTR(idUser, LASTPOS('<', idUser)+1)
                        idUser = SUBSTR(idUser, 1,  POS('>', idUser)-1)
                        idUser = STRIP(idUser)
                        handle = STRIP(handle)
                    END
                END
                IF TRANSLATE(mailHead) = 'REPLY-TO' THEN
                DO
                    idUser = mailText
                    ReplyTo = 1
                END
            END
            idUser = 'INET:'idUser
        END
        IF \(TRANSLATE(DELSTR(title, 4)) = 'RE:') THEN
        DO
            title = 'RE:'title
        END
        CALL LINEOUT sayFile, 'TO:'idUser
        CALL LINEOUT sayFile, 'SUB:'title
        IF \(handleTxt = '') THEN CALL LINEOUT sayFile, 'FROM:'handleTxt
        CALL LINEOUT sayFile, ''
        LINEIN(tmpFile, 1, 0)
        DO WHILE LINES(tmpFile)
            CALL LINEOUT sayFile, textQuote||LINEIN(tmpFile)
        END
        CALL LINEOUT tmpFile
        SAY '- 'idUser'@ւ̃X|X -'
    END
END
IF \(signupTxt = '') THEN
DO
    CALL LINEOUT sayFile, ''
    rc = SysFileTree(signupTxt, 'signFile', 'FO')
    IF signFile.0 > 0 THEN
    DO
        LINEIN(signupTxt, 1, 0)
        DO WHILE LINES(signupTxt)
            CALL LINEOUT sayFile, LINEIN(signupTxt)
        END
        CALL LINEOUT signupTxt
    END
    ELSE
    DO
        signText = signupTxt
        IF POS('"', signText) = 1 & LASTPOS('"', signText) = LENGTH(signText) THEN signText = SUBSTR(signText, 2, LENGTH(signText) - 2)
        CALL LINEOUT sayFile, signText
    END
END
DO FOREVER
    CALL LINEOUT sayFile
    exeEditor sayFile
    LINEIN(sayFile, 1, 0)
    DO WHILE LINES(sayFile)
        SAY LINEIN(sayFile)
    END
    DO FOREVER
        SAY 'C (1:C  2:Ȃ)'
        CALL CHAROUT , 'F'
        cmdOkNg = pullInput()
        IF cmdOkNg = '1' | cmdOkNg = '2' THEN LEAVE
    END
    IF cmdOkNg = '2' THEN LEAVE
END
DO FOREVER
    SAY 'M (1:M  2:Ȃ)'
    CALL CHAROUT , 'F'
    cmdOkNg = pullInput()
    IF cmdOkNg = '1' | cmdOkNg = '2' THEN LEAVE
END
IF cmdOkNg = '1' THEN
DO
    CALL LINEOUT padFile
    CALL LINEOUT padFile, '*MAIL'
    LINEIN(sayFile, 1, 0)
    sayLine = LINEIN(sayFile)
    IF \(TRANSLATE(sayLine) = 'TO:NONE') THEN
    DO
        CALL LINEOUT padFile, sayLine
        sayLine = LINEIN(sayFile)
        IF TRANSLATE(sayLine) = 'SUB:NONE' THEN sayLine = LINEIN(sayFile)
        IF TRANSLATE(DELSTR(sayLine, 5)) = 'SUB:' THEN
        DO
            CALL LINEOUT padFile, sayLine
        END
        ELSE
        DO
            CALL LINEOUT padFile, 'SUB:^Cg̓͂Y!?'
            CALL LINEOUT padFile, sayLine
        END
        DO WHILE LINES(sayFile)
            sayLine = LINEIN(sayFile)
            IF \(sayLine = '/POST') &,
               \(sayLine = '/E'  ) THEN CALL LINEOUT padFile, sayLine
        END
        CALL LINEOUT padFile, '/POST'
        CALL LINEOUT padFile
        SAY '|M|'
    END
END
CALL LINEOUT sayFile
rc = SysFileDelete(sayFile)
RETURN

/*--------------------------------------------------------*/
/** Xg\[`
 */
mesList: ARG cmdForum cmdMes
rc = SysFileTree(dirTemp||goForum'\'RIGHT(cmdMes, 2, 0)'*.$$$', 'mesFile', 'FO')
SAY 'ԍ   ID       o^      TO     CO 薼'
DO i=1 to mesFile.0
    LINEIN(mesFile.i, 1, 0)
    mesLine1 = LINEIN(mesFile.i)
    mesLine2 = LINEIN(mesFile.i)
    PARSE VAR mesLine1 numMes '/' maxMes idUser title
    numMes  = STRIP(numMes)
    maxMes  = STRIP(maxMes)
    idUser  = STRIP(idUser)
    title   = STRIP(title )
    handle  = DELSTR(title,    17)
    title   = DELSTR(title, 1, 18)
    handle  = STRIP(handle)
    title   = STRIP(title )
    PARSE VAR mesLine2 '(' fndMes ')' dateMes timeMes comment
    fndMes  = STRIP(fndMes )
    dateMes = STRIP(dateMes)
    timeMes = STRIP(timeMes)
    comment = STRIP(comment)
    toNo = ''
    coNo = ''
    IF POS('ւ̃Rg', comment) > 0 THEN
        toNo = DELSTR(comment,    POS('ւ̃Rg', comment))
    IF POS('RgF', comment) > 0 THEN
        coNo = DELSTR(comment, 1, POS('RgF', comment) + 11)
    numMes  = STRIP(numMes, 'L', '0')
    SAY RIGHT(numMes, 6)' 'idUser' 'DELSTR(dateMes, 1, 3)' '||,
        timeMes' 'RIGHT(toNo, 5, '0')||RIGHT(coNo, 4)' 'title
    CALL LINEOUT mesFile.i
END
RETURN

/*--------------------------------------------------------*/
/** \[`
 */
mesView: ARG cmdForum cmdMes cmdRead
tmpFile = dirTemp||cmdForum'\'RIGHT(cmdMes, 2, 0)||RIGHT(cmdRead, 6, 0)'.$$$'
rc = SysFileTree(tmpFile, 'mesFile', 'FO')
IF mesFile.0 = 0 THEN
DO
    cmdStr ='ERROR'
    SAY ''
    SAY 'Y锭܂'
    SAY ''
    RETURN
END
LINEIN(tmpFile, 1, 0)
IF LINES(tmpFile) = 1 & messFlush = 'ON' THEN CALL SysCls
cntPause = 0
DO WHILE LINES(tmpFile)
    tmpLine = LINEIN(tmpFile)
    SAY tmpLine
    cntPause = cntPause + TRUNC(LENGTH(tmpLine) / 80) + 1
    IF cntPause >= morePause THEN
    DO
        CALL CHAROUT , 'more>'
        dmyCmd = pullInput()
        cntPause = 0
    END
END
CALL LINEOUT tmpFile
RETURN

/*--------------------------------------------------------*/
/** 쐬[`
 */
mesSay: ARG cmdForum cmdMes reMes
tmpFile = dirTemp||cmdForum'\'RIGHT(cmdMes, 2, 0)||RIGHT(reMes, 6, 0)'.$$$'
sayFile = dirTemp||cmdForum'\'RIGHT(cmdMes, 2, 0)'NEWSAY.$$$'
CALL LINEOUT sayFile,, 1
IF \(reMes = '') THEN
DO
    LINEIN(tmpFile, 1, 0)
    sayLine = LINEIN(tmpFile)
    PARSE VAR sayLine numMes '/' maxMes idUser title
    numMes = STRIP(numMes)
    maxMes = STRIP(maxMes)
    idUser = STRIP(idUser)
    handle  = DELSTR(title,    17)
    title   = DELSTR(title, 1, 18)
    handle  = STRIP(handle)
    title   = STRIP(title )
    IF \(TRANSLATE(DELSTR(title, 4)) = 'RE:') THEN
    DO
        title = 'RE:'title
    END
    CALL LINEOUT sayFile, 'SUB:'title
    CALL LINEOUT sayFile, ''
    LINEIN(tmpFile, 1, 0)
    DO WHILE LINES(tmpFile)
        CALL LINEOUT sayFile, textQuote||LINEIN(tmpFile)
    END
    CALL LINEOUT tmpFile
    SAY numMes' ւ̃Rg'
END
ELSE CALL LINEOUT sayFile, 'SUB:NONE'
IF \(signupTxt = '') THEN
DO
    CALL LINEOUT sayFile, ''
    rc = SysFileTree(signupTxt, 'signFile', 'FO')
    IF signFile.0 > 0 THEN
    DO
        LINEIN(signupTxt, 1, 0)
        DO WHILE LINES(signupTxt)
            CALL LINEOUT sayFile, LINEIN(signupTxt)
        END
        CALL LINEOUT signupTxt
    END
    ELSE
    DO
        signText = signupTxt
        IF POS('"', signText) = 1 & LASTPOS('"', signText) = LENGTH(signText) THEN signText = SUBSTR(signText, 2, LENGTH(signText) - 2)
        CALL LINEOUT sayFile, signText
    END
END
DO FOREVER
    CALL LINEOUT sayFile
    exeEditor sayFile
    LINEIN(sayFile, 1, 0)
    DO WHILE LINES(sayFile)
        SAY LINEIN(sayFile)
    END
    DO FOREVER
        SAY 'C (1:C  2:Ȃ)'
        CALL CHAROUT , 'F'
        cmdOkNg = pullInput()
        IF cmdOkNg = '1' | cmdOkNg = '2' THEN LEAVE
    END
    IF cmdOkNg = '2' THEN LEAVE
END
DO FOREVER
    SAY 'o^ (1:M  2:Ȃ)'
    CALL CHAROUT , 'F'
    cmdOkNg = pullInput()
    IF cmdOkNg = '1' | cmdOkNg = '2' THEN LEAVE
END
IF cmdOkNg = '1' THEN
DO
    CALL LINEOUT padFile
    CALL LINEOUT padFile, '*GO 'cmdForum
    CALL LINEOUT padFile, '*MES 'cmdMes
    IF \(reMes = '') THEN
        CALL LINEOUT padFile, '*RE 'reMes
    ELSE
        CALL LINEOUT padFile, '*SAY'
    LINEIN(sayFile, 1, 0)
    sayLine = LINEIN(sayFile)
    IF TRANSLATE(sayLine) = 'SUB:NONE' THEN sayLine = LINEIN(sayFile)
    IF TRANSLATE(DELSTR(sayLine, 5)) = 'SUB:' THEN
    DO
        CALL LINEOUT padFile, sayLine
    END
    ELSE
    DO
        CALL LINEOUT padFile, 'SUB:^Cg̓͂Y!?'
        CALL LINEOUT padFile, sayLine
    END
    DO WHILE LINES(sayFile)
        sayLine = LINEIN(sayFile)
        IF \(sayLine = '/POST') &,
           \(sayLine = '/E'  ) THEN CALL LINEOUT padFile, sayLine
    END
    CALL LINEOUT padFile, '/POST'
    CALL LINEOUT padFile
    SAY '|o^|'
END
CALL LINEOUT sayFile
rc = SysFileDelete(sayFile)
RETURN

/*--------------------------------------------------------*/
/** L[͑p[`
 */
pullInput:
IF doCommand = '' THEN
DO
    PULL cmdLine
    PARSE VAR cmdLine chkStr chkOpt
    IF chkStr = 'DO' THEN
    DO
        cmdLine = chkOpt
        PARSE VAR cmdLine chkStr '/' chkOpt
        fndForum = 0
        DO i=1 to nifForum.0
            PARSE VAR nifForum.i goForum nameForum
            IF goForum = chkStr THEN
            DO
                fndForum = 1
                LEAVE
            END
        END
        IF fndForum = 1 THEN
        DO
            cmdLine = 'GO 'cmdLine
        END
        doCommand = cmdLine
        cmdLine = 'DO'
    END
END
ELSE
DO
    PARSE VAR doCommand cmdLine '/' doCommand
    SAY cmdLine
END
RETURN cmdLine

/*--------------------------------------------------------*/
/** Ot@C̉̓[`
 */
logLoad: ARG loadFile
SAY ''
CALL CHAROUT , 'Loading File(' loadFile '): '
tmpFile = ''
fndMail = 0
fndMes  = 0
logGet  = 0
logLast = ''
logLine = ''
LINEIN(loadFile, 1, 0)
DO WHILE LINES(loadFile)
    logGet = (logGet + 1) // 50
    IF logGet = 0 THEN CALL CHAROUT , '*'

    logLast = logLine
    logLine = LINEIN(loadFile)

    IF POS('OLOG OUT ', logLine) = 1 THEN
    DO
        dateLogout = SUBSTR(logLine, 13)
    END

    /* NIFTYɂ鏑ݕ͂̏I[𔻒f */
    IF POS('MAIL>'    , logLine) = 1 THEN fndMes = 0
    IF POS('BBS>'     , logLine) = 1 THEN fndMes = 0
    IF POS('PATIO(N)>', logLine) = 1 THEN fndMes = 0
    IF POS('FORUM>'   , logLine) = 1 THEN fndMes = 0
    IF POS('CCS(N)>'  , logLine) = 1 THEN fndMes = 0
    IF POS(''       , logLine) = 1 THEN
    DO
        OPTIONS EXMODE
        IF DATATYPE(SUBSTR(logLine, 2), 'C') = 0 &,
           DATATYPE(SUBSTR(logLine, 2), 'D') = 0 THEN
        DO
            fndMes = 0
        END
        OPTIONS NOEXMODE
    END
    /* NIFTỶcςƂ𔻒f */
    IF     POS('-'   , logLine) = 1               &,
       LASTPOS('-'   , logLine) = LENGTH(logLine) &,
           POS('MES(', logLine) > 0               &,
           POS('):'  , logLine) = POS('MES(', logLine) + 6 THEN
    DO
        fndMes = 0
        PARSE VAR logLine '- ' logForum 'MES(' logMes '):' logSub ' -'
        logSub   = STRIP(logSub)
        logDate  = SUBSTR(logSub, LENGTH(logSub) - 7)
        logSub   = DELSTR(logSub, LENGTH(logSub) - 7)
        logForum = STRIP(logForum)
        logMes   = STRIP(logMes)
        logDate  = STRIP(logDate)
        logSub   = STRIP(logSub)
        varMes   = logForum'.mes.'logMes
        rc = VALUE(varMes, logSub)
        rc = VALUE(varMes'.date', SUBSTR(logDate, 4, 5))
    END
    IF     POS('|c', logLine) = 1                   &,
       LASTPOS('|'      , logLine) = LENGTH(logLine) - 1 &,
           POS(' :', logLine) > 0                   &,
           POS(' :'  , logLine) > 0 THEN
    DO
        fndMes = 0
        PARSE VAR logLine '|c' logMes logSub ' :' logMax ' :' logUnrd '|'
        logMes  = STRIP(logMes)
        logSub  = STRIP(logSub)
        logMax  = STRIP(logMax)
        logUnrd = STRIP(logUnrd)
        varMes  = logForum'.mes.'logMes
        rc = VALUE(varMes, logSub)
        IF logMax > VALUE(varMes'.max') THEN rc = VALUE(varMes'.max', logMax )
    END

    /** NIFTYɂ鏑ݕ͂̐擪𔻒f
     */
    PARSE VAR logLine numMes '/' maxMes idUser title
    posNum = POS('/', logLine)
    IF posNum = 6 THEN
    DO
        posIdUser = 13
        posHandle = 23
        posTitle  = 40
    END
    ELSE
    DO
        posIdUser = 11
        posHandle = 21
        posTitle  = 39
    END
    numMes = STRIP(numMes)
    maxMes = STRIP(maxMes)
    idUser = STRIP(idUser)
    handle  = DELSTR(title,    17)
    title   = DELSTR(title, 1, 18)
    handle  = STRIP(handle)
    title   = STRIP(title )
    IF (posNum = 4 | posNum = 6) &,
       \(LENGTH(numMes) = 0) &,
        (DATATYPE(numMes,'N') = 1) &,
       \(LENGTH(maxMes) = 0) &,
        (DATATYPE(maxMes,'N') = 1) &,
       \(LENGTH(idUser) = 0) &,
       \(LENGTH(handle) = 0) &,
       \(LENGTH(title ) = 0) &,
        (POS(idUser, logLine, posIdUser) = posIdUser) &,
        (POS(handle, logLine, posHandle) = posHandle) &,
        (POS(title , logLine, posTitle ) = posTitle ) &,
        (LENGTH(idUser) = 8) THEN
    DO
        IF \(tmpFile = '') THEN CALL LINEOUT tmpFile
        logTop  = logLine
        logLine = LINEIN(loadFile)
        PARSE VAR logLine '(' fndMes ')' dateMes timeMes comment
        fndMes  = STRIP(fndMes )
        dateMes = STRIP(dateMes)
        timeMes = STRIP(timeMes)
        comment = STRIP(comment)
        tmpFile = dirTemp||logForum'\'RIGHT(fndMes, 2, 0)||RIGHT(numMes, 6, 0)'.$$$'
        rc = SysMkDir(dirTemp||logForum)
        CALL LINEOUT tmpFile, logTop, 1
        varMes  = logForum'.mes.'fndMes
        IF maxMes > VALUE(varMes'.max') THEN rc = VALUE(varMes'.max', maxMes )
        rc = VALUE(varMes'.unrd', VALUE(varMes'.unrd') + 1)
    END

    /** NIFTYɂ郁[͂̏I[𔻒f
     */
    IF POS('MAIL>'  , logLine) = 1 THEN fndMail = 0
    IF POS('action:', logLine) = 1 THEN fndMail = 0

    /** NIFTYɂ郁[͂̐擪𔻒f
     */
    IF fndMes = 0 & logLast = '' &,
       SUBSTR(logLine, 43, 1) = '/' &,
       SUBSTR(logLine, 46, 1) = '/' &,
       SUBSTR(logLine, 52, 1) = ':' THEN
    DO
        logTop  = logLine
        logLine = LINEIN(loadFile)
        IF POS('    薼F', logLine) = 1 THEN
        DO
            IF \(tmpFile = '') THEN CALL LINEOUT tmpFile
            PARSE VAR logTop fndMail handle idUser dateMes timeMes
            fndMail = STRIP(fndMail)
            tmpFile = dirTemp'NIFMAIL\MAIL'RIGHT(fndMail, 4, 0)'.$$$'
            CALL LINEOUT tmpFile, '', 1
            CALL LINEOUT tmpFile, logTop
        END
    END

    /** ݕ͂e|t@Cɐ؂o
     */
    IF \(fndMes = 0) | \(fndMail = 0) THEN
    DO
        CALL LINEOUT tmpFile, logLine
    END
    ELSE
    DO
        IF POS(''    , logLine) = 1 &,
           POS('    ', logLine) > 0 THEN
        DO
            PARSE VAR logLine '' logFname '    ' logForum
            logForum = STRIP(logForum)
            fndForum = 0
            DO i=1 to nifForum.0
                PARSE VAR nifForum.i goForum nameForum
                IF goForum = logForum THEN fndForum = 1
            END
            IF fndForum = 0 THEN
            DO
                nifForum.0 = nifForum.0 + 1
                rc = VALUE('nifForum.'nifForum.0, logForum' 'logFname'')
                DO i=1 to 20
                    rc = VALUE(logForum'.mes.'i, '')
                    rc = VALUE(logForum'.mes.'i'.max' , '')
                    rc = VALUE(logForum'.mes.'i'.unrd', 0 )
                    rc = VALUE(logForum'.mes.'i'.date', '')
                END
            END
        END
    END
END
CALL LINEOUT loadFile
IF \(tmpFile = '') THEN CALL LINEOUT tmpFile
SAY ''
RETURN

